@use './styles/code-block.variables' as *;

$white-space: pre-wrap;

digi-code-block {
	@include digi-code-block--variables;
	$base: '.digi-code-block';

	display: block;

	.digi-code-block {
		border-radius: var(--digi--code-block--border-radius);
		border: var(--digi--code-block--border);
		overflow: hidden;
		position: relative;

		pre {
			margin: 0;
		}

		&--light {
			/**
      * a11y-light theme for JavaScript, CSS, and HTML
      * Based on the okaidia theme: https://github.com/PrismJS/prism/blob/gh-pages/themes/prism-okaidia.css
      * @author ericwbailey
      */

			code[class*='language-'],
			pre[class*='language-'] {
				color: #545454;
				background: none;
				font-family: var(--digi--global--typography--font-family--mono);
				text-align: left;
				white-space: $white-space;
				word-spacing: normal;
				word-break: normal;
				word-wrap: normal;
				line-height: 1.5;

				-moz-tab-size: 4;
				-o-tab-size: 4;
				tab-size: 4;

				-webkit-hyphens: none;
				-moz-hyphens: none;
				-ms-hyphens: none;
				hyphens: none;
			}

			/* Code blocks */
			pre[class*='language-'] {
				padding: 1em;
				overflow: auto;
			}

			:not(pre) > code[class*='language-'],
			pre[class*='language-'] {
				background: #fefefe;
			}

			/* Inline code */
			:not(pre) > code[class*='language-'] {
				padding: 0.1em;
				white-space: normal;
			}

			.token.comment,
			.token.prolog,
			.token.doctype,
			.token.cdata {
				color: #696969;
			}

			.token.punctuation {
				color: #545454;
			}

			.token.property,
			.token.tag,
			.token.constant,
			.token.symbol,
			.token.deleted {
				color: #007faa;
			}

			.token.boolean,
			.token.number {
				color: #008000;
			}

			.token.selector,
			.token.attr-name,
			.token.string,
			.token.char,
			.token.builtin,
			.token.inserted {
				color: #aa5d00;
			}

			.token.operator,
			.token.entity,
			.token.url,
			.language-css .token.string,
			.style .token.string,
			.token.variable {
				color: #008000;
			}

			.token.atrule,
			.token.attr-value,
			.token.function {
				color: #aa5d00;
			}

			.token.keyword {
				color: #d91e18;
			}

			.token.regex,
			.token.important {
				color: #d91e18;
			}

			.token.important,
			.token.bold {
				font-weight: bold;
			}
			.token.italic {
				font-style: italic;
			}

			.token.entity {
				cursor: help;
			}

			@media screen and (-ms-high-contrast: active) {
				code[class*='language-'],
				pre[class*='language-'] {
					color: windowText;
					background: window;
				}

				:not(pre) > code[class*='language-'],
				pre[class*='language-'] {
					background: window;
				}

				.token.important {
					background: highlight;
					color: window;
					font-weight: normal;
				}

				.token.atrule,
				.token.attr-value,
				.token.function,
				.token.keyword,
				.token.operator,
				.token.selector {
					font-weight: bold;
				}

				.token.attr-value,
				.token.comment,
				.token.doctype,
				.token.function,
				.token.keyword,
				.token.operator,
				.token.property,
				.token.string {
					color: highlight;
				}

				.token.attr-value,
				.token.url {
					font-weight: normal;
				}
			}
		}

		&--dark {
			/**
      * a11y-dark theme for JavaScript, CSS, and HTML
      * Based on the okaidia theme: https://github.com/PrismJS/prism/blob/gh-pages/themes/prism-okaidia.css
      * @author ericwbailey
      */

			#{$base}__button {
				--digi--button--color--text--function--default: var(--digi--color--text--inverted);
				--digi--button--color--text--function--hover: var(--digi--color--text--inverted);
				--digi--button--color--icon--function--default: var(--digi--color--text--inverted);
				--digi--button--color--icon--function--hover: var(--digi--color--text--inverted);
			}

			code[class*='language-'],
			pre[class*='language-'] {
				color: #f8f8f2;
				background: none;
				font-family: var(--digi--global--typography--font-family--mono);
				text-align: left;
				white-space: $white-space;
				word-spacing: normal;
				word-break: normal;
				word-wrap: normal;
				line-height: 1.5;

				-moz-tab-size: 4;
				-o-tab-size: 4;
				tab-size: 4;

				-webkit-hyphens: none;
				-moz-hyphens: none;
				-ms-hyphens: none;
				hyphens: none;
			}

			/* Code blocks */
			pre[class*='language-'] {
				padding: 1em;
				overflow: auto;
			}

			:not(pre) > code[class*='language-'],
			pre[class*='language-'] {
				//background: var(--digi--color--background--inverted-1);
				--digi--color--background--inverted-3:#272727;
				background: var(--digi--color--background--inverted-3);
			}

			/* Inline code */
			:not(pre) > code[class*='language-'] {
				padding: 0.1em;
				white-space: normal;
			}

			.token.comment,
			.token.prolog,
			.token.doctype,
			.token.cdata {
				color: #d4d0ab;
			}

			.token.punctuation {
				color: #fefefe;
			}

			.token.property,
			.token.tag,
			.token.constant,
			.token.symbol,
			.token.deleted {
				color: #ffa07a;
			}

			.token.boolean,
			.token.number {
				color: #00e0e0;
			}

			.token.selector,
			.token.attr-name,
			.token.string,
			.token.char,
			.token.builtin,
			.token.inserted {
				color: #abe338;
			}

			.token.operator,
			.token.entity,
			.token.url,
			.language-css .token.string,
			.style .token.string,
			.token.variable {
				color: #00e0e0;
			}

			.token.atrule,
			.token.attr-value,
			.token.function {
				color: #ffd700;
			}

			.token.keyword {
				color: #00e0e0;
			}

			.token.regex,
			.token.important {
				color: #ffd700;
			}

			.token.important,
			.token.bold {
				font-weight: bold;
			}
			.token.italic {
				font-style: italic;
			}

			.token.entity {
				cursor: help;
			}

			@media screen and (-ms-high-contrast: active) {
				code[class*='language-'],
				pre[class*='language-'] {
					color: windowText;
					background: window;
				}

				:not(pre) > code[class*='language-'],
				pre[class*='language-'] {
					background: window;
				}

				.token.important {
					background: highlight;
					color: window;
					font-weight: normal;
				}

				.token.atrule,
				.token.attr-value,
				.token.function,
				.token.keyword,
				.token.operator,
				.token.selector {
					font-weight: bold;
				}

				.token.attr-value,
				.token.comment,
				.token.doctype,
				.token.function,
				.token.keyword,
				.token.operator,
				.token.property,
				.token.string {
					color: highlight;
				}

				.token.attr-value,
				.token.url {
					font-weight: normal;
				}
			}
		}
		&__toolbar {
			padding-bottom: 0.5rem;
			display: flex;
			justify-content: flex-end;
			position: absolute;
			bottom: 0;
			width: 100%;
		}

		&__button {
			margin-right: var(--digi--margin--smaller);
		}
	}
}
